package main

import (
	"context"
	"errors"
)

var users []User
var ssh_keys []SSHKey

//var servers []Server
//var server_definitions []ServerDefinition
//var manifests []Manifest
//var jobs []Job
//var hosts []Host

func main() {
	var err error
	ctx := context.Background()
	dsn := "postgres://postgres:Initial1@localhost:15432/anvil?sslmode=disable"
	// dsn := "unix://user:pass@dbname/var/run/postgresql/.s.PGSQL.5432"

	anvildb := ConnectAnvilDB(dsn)
	// Turn these into funcs with error handling, logging, return vals etc.
	if usererr := anvildb.NewSelect().
		// Turning *Feed into an interface &Feed{}
		Model(&User{}).
		OrderExpr("user_uuid ASC").
		Limit(10).
		Scan(ctx, &users); usererr != nil {
		errors.Join(usererr, err)
	}
	if sshkeyerr := anvildb.NewSelect().
		Model(&SSHKey{}).
		OrderExpr("ssh_key_user_name ASC").
		Scan(ctx, &ssh_keys); sshkeyerr != nil {
		errors.Join(sshkeyerr, err)
	}
	//	fmt.Printf("##\n## Users\n###\n\n")
	//	for _, val := range users {
	//		fmt.Printf("%s\n", val.Username)
	//	}
	//	fmt.Printf("##\n## SSH Keys\n##\n\n")
	//	for _, val := range ssh_keys {
	//		fmt.Printf("UUID :\n%s\n", val.UUID.String())
	//		fmt.Printf("Username :\n%s\n", val.Username)
	//		fmt.Printf("PublicKey :\n%s\n", val.PublicKey)
	//		fmt.Printf("####\n\n")
	//	}
	//
	// fmt.Printf("%+v\n", users)
}
